#include <string.h>
#include "syntax.h"

Var::Var(char *name)
{	Name=strdup(name);
}

void Var::show()
{	printf(Name);
}

Const::Const(char *name)
{	Name=strdup(name);
}

void Const::show()
{	printf(Name);
}

App::App(Expr *func,Expr *arg):Func(func),Arg(arg)
{ }

void App::show()
{	printf("(");
	Func->show();
	printf(" ");
	Arg->show();
	printf(")");
}

Abs::Abs(Var *binder,Expr *body):Binder(binder),Body(body)
{ }

void Abs::show()
{	printf("(\\");
	Binder->show();
	printf(". ");
	Body->show();
	printf(")");
}
