#ifndef SYNTAX_INCLUDED
#define SYNTAX_INCLUDED

#include "common.h"

class Syntaxnode
{ 
public:
	virtual void show()=0;
};

class Expr : public Syntaxnode
{ };

class Var : public Expr
{	char *Name;
public:
	Var(char *);
	void show();
};

class Const : public Expr
{	char *Name;
public:
	Const(char *);
	void show();
};

class App : public Expr
{	Expr *Func,*Arg;
public:
	App(Expr *,Expr *);
	void show();
};

class Abs : public Expr
{	Var *Binder;
	Expr *Body;
public:
	Abs(Var *,Expr *);
	void show();
};

#endif
