%a 4000
%o 4000

lower		[a-z]
upper		[A-Z]
digit		[0-9]
special		[\+\-\*\/]
alphanum	{lower}|{upper}|{digit}|{special}
ws		\n|\ |\t

var		{lower}{alphanum}*
const		({upper}|{special}){alphanum}*

%{
#include <string.h>
#include "common.h"
#include "syntax.h"
#include "y.tab.h"

extern "C" int yywrap() { return 1; }
%}

%%

\(		{ return SY_OPEN; }
\)		{ return SY_CLOSE; }
\\		{ return SY_LAMBDA; }
\.		{ return SY_DOT; }

{var}		{ yylval.VarV=new Var(yytext); return SY_VAR; }
{const}		{ yylval.ConstV=new Const(yytext); return SY_CONST; }
{ws}		{  }
.		{ printf("Falsches Zeichen"); exit(1); }

%%
