{
module Parser where

import Scanner
import Syntax

happyError :: [Token] -> a
happyError rest = error $ "parse error Rest: "++show rest

}

%name parse

%tokentype { Token }

%token
	'('	{ SY_OPEN }
	')'	{ SY_CLOSE }
	'\\'	{ SY_LAMBDA }
	'.'	{ SY_DOT }
	var	{ SY_VAR $$ }
	const	{ SY_CONST $$ }


%%

Expr :: { Expr }
	: Prim			{ $1 }
	| Expr Prim		{ App $1 $2 }

Prim :: { Expr }
	: var			{ Var $1 }
	| const			{ Const $1 }
	| '(' Expr ')'		{ $2 }
	| '\\' var '.' Expr	{ Abs $2 $4 }
