module Scanner (Token(..),scan) where

import Char
import List

data Token = SY_OPEN | SY_CLOSE | SY_LAMBDA | SY_DOT
		| SY_VAR String | SY_CONST String
		deriving Show

scan :: String -> [Token]
scan [] = []
scan ('(':r) = SY_OPEN:scan r
scan (')':r) = SY_CLOSE:scan r
scan ('\\':r) = SY_LAMBDA:scan r
scan ('.':r) = SY_DOT:scan r
scan (z:r)	| isLower z = scanan SY_VAR z r
		| isUpper z = scanan SY_CONST z r
		| z `elem` "+-*/" = SY_CONST [z]:scan r
		| isSpace z = scan r
scan other = error$ "Falsches Zeichen: "++other

scanan constr z r = constr (z:vr):scan rr
  where (vr,rr) = span isAlphaNum r
