%{
#include "common.h"
#include "syntax.h"

Expr *parsedExpr;

int yyerror(char *)
{	return 1;
}
%}

%token 		SY_OPEN SY_CLOSE SY_LAMBDA SY_DOT
%token <VarV>	SY_VAR
%token <ConstV>	SY_CONST

%type <ExprV>	Start Expr Appl Prim

%union	{
	 Var *VarV;
	 Const *ConstV;
	 Expr *ExprV;
	}

%start Start

%%

Start
	: Expr				{ parsedExpr=$1; $$=parsedExpr; }

Expr
	: Appl				{ $$=$1; }
	| SY_LAMBDA SY_VAR SY_DOT Expr	{ $$=new Abs($2,$4); }

Appl
	: Prim				{ $$=$1; }
	| Appl Prim			{ $$=new App($1,$2); }

Prim
	: SY_VAR			{ $$=$1; }
	| SY_CONST			{ $$=$1; }
	| SY_OPEN Expr SY_CLOSE		{ $$=$2; }

%%
